'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.install = exports.default = undefined;

var _omelette = require('omelette');

var _omelette2 = _interopRequireDefault(_omelette);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-invalid-this:"off" */
var complete = (0, _omelette2.default)('nps <script>');

exports.default = autocomplete;
exports.install = install;


function autocomplete() {
  var config = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  complete.on('script', onScript);
  complete.init();

  function onScript() {
    this.reply(getScripts(config.scripts));
  }
}

function install() {
  var destination = arguments.length <= 0 || arguments[0] === undefined ? '~/.bash_profile' : arguments[0];

  complete.setupShellInitFile(destination);
  return destination;
}

function getScripts(scriptsObject) {
  var prefix = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];
  var allScripts = arguments.length <= 2 || arguments[2] === undefined ? [] : arguments[2];

  var excludedKeys = ['default', 'script', 'description'];
  return Object.keys(scriptsObject).reduce(function (acc, key) {
    if ((0, _lodash.includes)(excludedKeys, key)) {
      return acc;
    }
    var value = scriptsObject[key];
    var kebabKey = (0, _lodash.kebabCase)(key);
    var deepKey = prefix ? prefix + '.' + kebabKey : kebabKey;
    acc.push(deepKey);
    if ((0, _lodash.isPlainObject)(value)) {
      getScripts(value, deepKey, acc);
    }
    return acc;
  }, allScripts);
}