'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

exports.default = kebabAndCamelCasify;


function kebabAndCamelCasify(obj) {
  return Object.keys(obj).reduce(function (result, key) {
    var camel = (0, _lodash.camelCase)(key);
    var kebab = (0, _lodash.kebabCase)(key);
    var val = obj[key];
    if ((0, _lodash.isPlainObject)(obj[key])) {
      val = kebabAndCamelCasify(val);
    }
    if (key !== camel || key !== kebab) {
      result[camel] = val;
      result[kebab] = val;
    } else {
      result[key] = val;
    }
    return result;
  }, obj);
}