'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resolveScriptObjectToScript = exports.default = undefined;

var _lodash = require('lodash');

exports.default = resolveScriptObjectToString;
exports.resolveScriptObjectToScript = resolveScriptObjectToScript;


function resolveScriptObjectToString(script) {
  var scriptObj = resolveScriptObjectToScript(script);
  if ((0, _lodash.isPlainObject)(scriptObj)) {
    return scriptObj.script;
  }
  return undefined;
}

function resolveScriptObjectToScript(script) {
  if ((0, _lodash.isPlainObject)(script)) {
    if (!(0, _lodash.isUndefined)(script.script)) {
      return script;
    } else if (!(0, _lodash.isUndefined)(script.default)) {
      return resolveScriptObjectToScript(script.default);
    }
  } else if ((0, _lodash.isString)(script)) {
    return { script: script };
  }
  return undefined;
}